#pragma once

#include <JuceHeader.h>

class TrackSegmentSource;

class MainComponent  : public juce::AudioAppComponent
{
public:
    MainComponent();
    ~MainComponent() override;

    void prepareToPlay (int samplesPerBlockExpected, double sampleRate) override;
    void getNextAudioBlock (const juce::AudioSourceChannelInfo& bufferToFill) override;
    void releaseResources() override;

    void paint (juce::Graphics& g) override;
    void resized() override;

private:
    std::unique_ptr<TrackSegmentSource> trackSegmentSource;
    std::unique_ptr<juce::ResamplingAudioSource> resamplingAudioSource;
    
    bool resamplingEnabled = true;

    JUCE_DECLARE_NON_COPYABLE_WITH_LEAK_DETECTOR (MainComponent)
};
